package org.eclipse.stardust.clustering;

import java.util.List;
import java.util.Map;

import org.eclipse.stardust.common.log.LogManager;
import org.eclipse.stardust.common.log.Logger;
import org.eclipse.stardust.engine.api.runtime.AdministrationService;
import org.eclipse.stardust.engine.api.runtime.Daemon;

public class StartupDaemonAction implements IDaemonAdministrationAction
{

	private static Logger LOG = LogManager.getLogger( StartupDaemonAction.class );
	private Map<String,List<String>> automaticDaemonStartup;
	
	public StartupDaemonAction( Map<String,List<String>> startupMap ) {
		this.automaticDaemonStartup = startupMap;
	}

	public void executeWithDaemon(AdministrationService adminService,
			Daemon daemon, String partition)
	{
		if( !daemon.isRunning() )
		{ 
			if( automaticDaemonStartup.containsKey(partition) &&
				automaticDaemonStartup.get(partition).contains(daemon.getType()) )
			{
				LOG.info("Automatically starting daemon "+daemon.getType());
				adminService.startDaemon(daemon.getType(), false);
			}
		}

	}

}
