package org.eclipse.stardust.clustering;

import org.eclipse.stardust.engine.api.runtime.AdministrationService;
import org.eclipse.stardust.engine.api.runtime.Daemon;
import org.eclipse.stardust.engine.api.runtime.DaemonExecutionState;

/**
 * Action to shut down a {@link Daemon}
 * 
 * @author JanHendrik.Scheufen
 */
public class StopDaemonAction implements IDaemonAdministrationAction {

	/**
	 * Tries to shutdown the daemon if it is running.
	 */
	public void executeWithDaemon(AdministrationService adminService,
			Daemon daemon, String partition)
	{
		if( daemon.getDaemonExecutionState() == DaemonExecutionState.OK )
			adminService.stopDaemon(daemon.getType(), false);
	}

}
